/* Processed by ecpg (2.8.0) */
/* These three include files are added by the preprocessor */
#include <ecpgtype.h>
#include <ecpglib.h>
#include <ecpgerrno.h>
#line 1 "cursor.pgc"
#include <stdio.h>
#include <string.h>
#include <stdlib.h>


#line 1 "/usr/local/pgsql/include/sqlca.h"
#ifndef POSTGRES_SQLCA_H
#define POSTGRES_SQLCA_H

#ifndef DLLIMPORT
#ifdef __CYGWIN__
#define DLLIMPORT __declspec (dllimport)
#else
#define DLLIMPORT
#endif /* __CYGWIN__ */
#endif /* DLLIMPORT */

#define SQLERRMC_LEN	70

#ifdef __cplusplus
extern		"C"
{
#endif

	struct sqlca
	{
		char		sqlcaid[8];
		long		sqlabc;
		long		sqlcode;
		struct
		{
			int			sqlerrml;
			char		sqlerrmc[SQLERRMC_LEN];
		}			sqlerrm;
		char		sqlerrp[8];
		long		sqlerrd[6];
		/* Element 0: empty						*/
		/* 1: OID of processed tuple if applicable			*/
		/* 2: number of rows processed				*/
		/* after an INSERT, UPDATE or				*/
		/* DELETE statement					*/
		/* 3: empty						*/
		/* 4: empty						*/
		/* 5: empty						*/
		char		sqlwarn[8];
		/* Element 0: set to 'W' if at least one other is 'W'	*/
		/* 1: if 'W' at least one character string		*/
		/* value was truncated when it was			*/
		/* stored into a host variable.				*/

		/*
		 * 2: if 'W' a (hopefully) non-fatal notice occured
		 *//* 3: empty */
		/* 4: empty						*/
		/* 5: empty						*/
		/* 6: empty						*/
		/* 7: empty						*/

		char		sqlext[8];
	};

	extern DLLIMPORT struct sqlca sqlca;


#ifdef __cplusplus
}

#endif

#endif

#line 4 "cursor.pgc"

/* exec sql whenever sql_warning  sqlprint ; */

#line 5 "cursor.pgc"

/* exec sql whenever sqlerror  do GiveUp (  ) ; */

#line 6 "cursor.pgc"


void GiveUp()
{
	fprintf(stderr, "Fatal Error\n");
	sqlprint();
	exit(1);
}

main(int argc, char *argv[])
{
  /* exec sql begin declare section */
   
   
   
   
  
#line 18 "cursor.pgc"
       struct varchar_town  { int len; char arr[ 64 ]; }  town   ;
 
#line 19 "cursor.pgc"
   int  town_ind   ;
 
#line 20 "cursor.pgc"
   double  shipping   ;
 
#line 21 "cursor.pgc"
   char  date [ 10 ]   ;
/* exec sql end declare section */
#line 22 "cursor.pgc"


  if(argc != 2) {
	printf("Usage: cursor town\n");
	exit(1);
  }

  strncpy(town.arr, argv[1], sizeof(town.arr));

  { ECPGconnect(__LINE__, "bpsimple" , NULL,NULL , NULL, 1); 
#line 31 "cursor.pgc"

if (sqlca.sqlwarn[0] == 'W') sqlprint();
#line 31 "cursor.pgc"

if (sqlca.sqlcode < 0) GiveUp (  );}
#line 31 "cursor.pgc"

  { ECPGtrans(__LINE__, NULL, "begin transaction");
#line 32 "cursor.pgc"

if (sqlca.sqlwarn[0] == 'W') sqlprint();
#line 32 "cursor.pgc"

if (sqlca.sqlcode < 0) GiveUp (  );}
#line 32 "cursor.pgc"

  





/* declare mycursor  cursor for select  oi . date_placed  , oi . shipping   from orderinfo oi where oi . customer_id  = ( select  c . customer_id   from customer c where c . customer_id  = oi . customer_id  and town  = ?   )   */
#line 39 "cursor.pgc"

  { ECPGdo(__LINE__, NULL, "declare mycursor  cursor for select  oi . date_placed  , oi . shipping   from orderinfo oi where oi . customer_id  = ( select  c . customer_id   from customer c where c . customer_id  = oi . customer_id  and town  = ?   )  ", 
	ECPGt_varchar,&(town),64L,1L,sizeof(struct varchar_town), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);
#line 40 "cursor.pgc"

if (sqlca.sqlwarn[0] == 'W') sqlprint();
#line 40 "cursor.pgc"

if (sqlca.sqlcode < 0) GiveUp (  );}
#line 40 "cursor.pgc"

  
  /* exec sql whenever not found  break ; */

#line 42 "cursor.pgc"

  while(1) {

    
{ ECPGdo(__LINE__, NULL, "fetch from mycursor", ECPGt_EOIT, 
	ECPGt_char,(date),10L,1L,10*sizeof(char), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(shipping),1L,1L,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);
#line 46 "cursor.pgc"

if (sqlca.sqlcode == ECPG_NOT_FOUND) break;
#line 46 "cursor.pgc"

if (sqlca.sqlwarn[0] == 'W') sqlprint();
#line 46 "cursor.pgc"

if (sqlca.sqlcode < 0) GiveUp (  );}
#line 46 "cursor.pgc"

             
    printf("%.*s <%.2f>\n", sizeof(date), date, shipping);

  }
  { ECPGdo(__LINE__, NULL, "close mycursor", ECPGt_EOIT, ECPGt_EORT);
#line 51 "cursor.pgc"

if (sqlca.sqlwarn[0] == 'W') sqlprint();
#line 51 "cursor.pgc"

if (sqlca.sqlcode < 0) GiveUp (  );}
#line 51 "cursor.pgc"

  { ECPGtrans(__LINE__, NULL, "commit");
#line 52 "cursor.pgc"

if (sqlca.sqlwarn[0] == 'W') sqlprint();
#line 52 "cursor.pgc"

if (sqlca.sqlcode < 0) GiveUp (  );}
#line 52 "cursor.pgc"

  { ECPGdisconnect(__LINE__, "ALL");
#line 53 "cursor.pgc"

if (sqlca.sqlwarn[0] == 'W') sqlprint();
#line 53 "cursor.pgc"

if (sqlca.sqlcode < 0) GiveUp (  );}
#line 53 "cursor.pgc"

}
